/**A colored flag that inputs a user-set value into the circuit. The input can
 * be toggled with the mouse.*/
public class UserInput extends Object {
  public UserInput(int x, int y) {
    super(x, y);
    output = new Output[1];
    output[0] = new Output(this, .5, 0);
  }

  protected void setPen() {
    super.setPen();
    if (output[0].get()) fill(TRUE);
    else                fill(FALSE);
  }

  public void draw() {
    setPen();
    beginShape();
    tvertex(-1, -.3);
    tvertex(.7, -.3);
    tvertex(1, 0);
    tvertex(.7, .3);
    tvertex(-1, .3);
    tvertex(-1, -.3);
    endShape();
  }

  public void tick() {
  };

  public void released() {
    if (mouseY-y == constrain(mouseY-y, -.3*size/2, .3*size/2) 
      && mouseX-x == constrain(mouseX-x, -size/2, size/2)) {
      output[0].set(!(output[0].get()));
      dirty = true;
    }
  }
}

