public class Wire extends Object {
  //Height and width of the wire.
  float yf, xf;

  public Wire(int x, int y) {
    super(x, y);
    size = 1; //Simplifies Hotspot management for a variable shape.
    yf = y;
    xf = x + 2*MOUSE_GRAB_RADIUS;
    //Wires are bidirectional.
    input     = new Input[1];
    output    = new Output[1];
    input[0]  = new Input(this, 0, 0);
    output[0] = new Output(this, xf-x, yf-y);
    things.add(this);
  }

  public void  setSize(int size) {
  }
  public float getSize() {
    return 1;
  }

  public void tick() {
    output[0].set(input[0].get());
  }

  protected void setPen() {
    super.setPen();
    if ((input[0].attached() && input[0].get())) stroke(TRUE);
    else								           stroke(FALSE);
  }

  public void draw() {
    setPen();
    line(x, y, xf, yf);
    drawHotspots();
  }

  protected void dragged() {
    if (this == active) {
      if (d1() < d2()) {
        //Move the "head" of the wire
        setX(mouseX);
        setY(mouseY);
      } 
      else if (d1() > d2()) {
        //Move the "tail" of the wire
        if (gridMode == OFF) {
          xf = mouseX;
          yf = mouseY;
        } else {
          xf = mouseX - (mouseX-GRID_SPACING/2)%GRID_SPACING + GRID_SPACING/2;
          yf = mouseY - (mouseY-GRID_SPACING/2)%GRID_SPACING + GRID_SPACING/2;
        }
      }

      //Move the Hotspots attached to the tail end.
      output[0].setX(xf-x);
      output[0].setY(yf-y);			
      input[0].associate();
      dirty = true;
    }
  }

  private float d1() {
    return dist(x, y, mouseX, mouseY);
  }
  private float d2() {
    return dist(xf, yf, mouseX, mouseY);
  }

  /**Calculates the distance from the wire to the mouse
   	 * @return The distance from the mouse to the nearest end of the wire
   	 */
  protected float distance() {
    if (d1() > d2()) return d2();
    else return d1();
  }
  public String toString() {
    return "Wire from ("+x+", "+y+") to ("+x+", "+y+")";
  }
}

